﻿///<reference path="../typings/globals/core-js/index.d.ts"/>
'use strict';

import { Component, EventEmitter, Inject, enableProdMode, ViewChild, NgModule, OnInit } from '@angular/core';
import { FormsModule } from '@angular/forms';
import { CommonModule } from '@angular/common';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { BrowserModule } from '@angular/platform-browser';
import { WjGridModule } from 'wijmo/wijmo.angular2.grid';
import { WjInputModule } from 'wijmo/wijmo.angular2.input';

import * as wjcInput from 'wijmo/wijmo.input';
import * as wjcGrid from 'wijmo/wijmo.grid';
import * as wjcCore from 'wijmo/wijmo';


import { DataSvc } from './services/DataSvc';

@Component({
    selector: 'app-cmp',
    templateUrl: '../src/AppCmp.html'
})
export class AppCmp implements OnInit {
    
    private dataSvc: DataSvc;
    public data: wjcCore.CollectionView;
    @ViewChild('flex') flex: wjcGrid.FlexGrid;
    constructor( @Inject(DataSvc) _dataSvc: DataSvc) {
        this.dataSvc = _dataSvc;
        this.data = new wjcCore.CollectionView(this.dataSvc.getData(10));
    }
    ngOnInit() {
        let rng = null;
        let tooltip = new wjcCore.Tooltip();
        this.flex.hostElement.addEventListener('mousemove', (e) => {
            let _ht = this.flex.hitTest(e);
            if (!_ht.range.equals(rng)) {
                // new cell selected , show tooltip
                if (_ht.cellType == wjcGrid.CellType.Cell) {
                    rng = _ht.range;
                    let cellElement = document.elementFromPoint(e.clientX, e.clientY),
                        cellBounds = this.flex.getCellBoundingRect(_ht.row, _ht.col),
                        data = wjcCore.escapeHtml(this.flex.getCellData(rng.row, rng.col, true));
                    let tooltipContent = `Cell ( ${rng.row}, ${rng.col} ) contains <b> ${data} `;
                    tooltip.show(this.flex.hostElement, tooltipContent, cellBounds);
                }
            }
        });
        this.flex.hostElement.addEventListener('mouseout', (e) => {
            tooltip.hide();
        });
    }

}
@NgModule({
    imports: [WjInputModule, WjGridModule, BrowserModule, FormsModule],
    declarations: [AppCmp],
    providers: [DataSvc],
    bootstrap: [AppCmp]
})
export class AppModule {
}


enableProdMode();
// Bootstrap application with hash style navigation and global services.
platformBrowserDynamic().bootstrapModule(AppModule);



